#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private WSTOpenRange[] cacheWSTOpenRange;
		private TWSTccI2[] cacheTWSTccI2;
		private DChannelTWST[] cacheDChannelTWST;
		private WSTTrendLine[] cacheWSTTrendLine;

		
		public WSTOpenRange WSTOpenRange(WTWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, WTWSTPreSessionTypeOR preSessionType, WTWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return WSTOpenRange(Input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public TWSTccI2 TWSTccI2(int period)
		{
			return TWSTccI2(Input, period);
		}

		public DChannelTWST DChannelTWST(TDmamaDonchianInput selectedInput, int period, TDmamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return DChannelTWST(Input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public WSTTrendLine WSTTrendLine(int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return WSTTrendLine(Input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}


		
		public WSTOpenRange WSTOpenRange(ISeries<double> input, WTWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, WTWSTPreSessionTypeOR preSessionType, WTWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			if (cacheWSTOpenRange != null)
				for (int idx = 0; idx < cacheWSTOpenRange.Length; idx++)
					if (cacheWSTOpenRange[idx].OpeningRangeTZSelector == openingRangeTZSelector && cacheWSTOpenRange[idx].S_OpeningRangeStart == s_OpeningRangeStart && cacheWSTOpenRange[idx].S_OpeningRangeEnd == s_OpeningRangeEnd && cacheWSTOpenRange[idx].PreSessionType == preSessionType && cacheWSTOpenRange[idx].PreSessionTZSelector == preSessionTZSelector && cacheWSTOpenRange[idx].S_PreSessionStart == s_PreSessionStart && cacheWSTOpenRange[idx].S_PreSessionEnd == s_PreSessionEnd && cacheWSTOpenRange[idx].EqualsInput(input))
						return cacheWSTOpenRange[idx];
			return CacheIndicator<WSTOpenRange>(new WSTOpenRange(){ OpeningRangeTZSelector = openingRangeTZSelector, S_OpeningRangeStart = s_OpeningRangeStart, S_OpeningRangeEnd = s_OpeningRangeEnd, PreSessionType = preSessionType, PreSessionTZSelector = preSessionTZSelector, S_PreSessionStart = s_PreSessionStart, S_PreSessionEnd = s_PreSessionEnd }, input, ref cacheWSTOpenRange);
		}

		public TWSTccI2 TWSTccI2(ISeries<double> input, int period)
		{
			if (cacheTWSTccI2 != null)
				for (int idx = 0; idx < cacheTWSTccI2.Length; idx++)
					if (cacheTWSTccI2[idx].Period == period && cacheTWSTccI2[idx].EqualsInput(input))
						return cacheTWSTccI2[idx];
			return CacheIndicator<TWSTccI2>(new TWSTccI2(){ Period = period }, input, ref cacheTWSTccI2);
		}

		public DChannelTWST DChannelTWST(ISeries<double> input, TDmamaDonchianInput selectedInput, int period, TDmamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			if (cacheDChannelTWST != null)
				for (int idx = 0; idx < cacheDChannelTWST.Length; idx++)
					if (cacheDChannelTWST[idx].SelectedInput == selectedInput && cacheDChannelTWST[idx].Period == period && cacheDChannelTWST[idx].TrendMode == trendMode && cacheDChannelTWST[idx].MultiplierFast == multiplierFast && cacheDChannelTWST[idx].MultiplierSlow == multiplierSlow && cacheDChannelTWST[idx].EqualsInput(input))
						return cacheDChannelTWST[idx];
			return CacheIndicator<DChannelTWST>(new DChannelTWST(){ SelectedInput = selectedInput, Period = period, TrendMode = trendMode, MultiplierFast = multiplierFast, MultiplierSlow = multiplierSlow }, input, ref cacheDChannelTWST);
		}

		public WSTTrendLine WSTTrendLine(ISeries<double> input, int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			if (cacheWSTTrendLine != null)
				for (int idx = 0; idx < cacheWSTTrendLine.Length; idx++)
					if (cacheWSTTrendLine[idx].Strength == strength && cacheWSTTrendLine[idx].NumberOfTrendLines == numberOfTrendLines && cacheWSTTrendLine[idx].OldTrendsOpacity == oldTrendsOpacity && cacheWSTTrendLine[idx].AlertOnBreak == alertOnBreak && cacheWSTTrendLine[idx].EqualsInput(input))
						return cacheWSTTrendLine[idx];
			return CacheIndicator<WSTTrendLine>(new WSTTrendLine(){ Strength = strength, NumberOfTrendLines = numberOfTrendLines, OldTrendsOpacity = oldTrendsOpacity, AlertOnBreak = alertOnBreak }, input, ref cacheWSTTrendLine);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.WSTOpenRange WSTOpenRange(WTWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, WTWSTPreSessionTypeOR preSessionType, WTWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.WSTOpenRange(Input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTccI2 TWSTccI2(int period)
		{
			return indicator.TWSTccI2(Input, period);
		}

		public Indicators.DChannelTWST DChannelTWST(TDmamaDonchianInput selectedInput, int period, TDmamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.DChannelTWST(Input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.WSTTrendLine WSTTrendLine(int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.WSTTrendLine(Input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}


		
		public Indicators.WSTOpenRange WSTOpenRange(ISeries<double> input , WTWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, WTWSTPreSessionTypeOR preSessionType, WTWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.WSTOpenRange(input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTccI2 TWSTccI2(ISeries<double> input , int period)
		{
			return indicator.TWSTccI2(input, period);
		}

		public Indicators.DChannelTWST DChannelTWST(ISeries<double> input , TDmamaDonchianInput selectedInput, int period, TDmamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.DChannelTWST(input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.WSTTrendLine WSTTrendLine(ISeries<double> input , int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.WSTTrendLine(input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.WSTOpenRange WSTOpenRange(WTWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, WTWSTPreSessionTypeOR preSessionType, WTWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.WSTOpenRange(Input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTccI2 TWSTccI2(int period)
		{
			return indicator.TWSTccI2(Input, period);
		}

		public Indicators.DChannelTWST DChannelTWST(TDmamaDonchianInput selectedInput, int period, TDmamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.DChannelTWST(Input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.WSTTrendLine WSTTrendLine(int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.WSTTrendLine(Input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}


		
		public Indicators.WSTOpenRange WSTOpenRange(ISeries<double> input , WTWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, WTWSTPreSessionTypeOR preSessionType, WTWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.WSTOpenRange(input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTccI2 TWSTccI2(ISeries<double> input , int period)
		{
			return indicator.TWSTccI2(input, period);
		}

		public Indicators.DChannelTWST DChannelTWST(ISeries<double> input , TDmamaDonchianInput selectedInput, int period, TDmamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.DChannelTWST(input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.WSTTrendLine WSTTrendLine(ISeries<double> input , int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.WSTTrendLine(input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}

	}
}

#endregion
